                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 8: lexical addressing   */
                     /*-----------------------------------*/
                     /*            dictionary             */
                     /*-----------------------------------*/

#include <stdio.h>

#include "SlipMain.h"
#include "SlipEnvironment.h"
#include "SlipDictionary.h"

/*------------------------------ private variables ---------------------------*/

static ENV_type Current_environment;
static FRM_type Current_frame;
static FRM_type Previous_frame;

static UNS_type Current_frame_size;
static UNS_type Current_scope_level;
static UNS_type Previous_frame_size;

/*------------------------------ private functions ---------------------------*/

static UNS_type get_offset(SYM_type Variable,
                           UNS_type Size,
                           FRM_type Frame)
  { FRM_type frame;
    UNS_type offset = Size;
    for (frame = Frame;
         !is_NUL(frame);
         frame = frame->frm)
      { if (frame->var == Variable)
          return offset; 
        offset--; }
    return 0; }

/*------------------------------ public functions ----------------------------*/

NIL_type Dictionary_Checkpoint(NIL_type)
  { Previous_frame = Current_frame;
    Previous_frame_size = Current_frame_size; }

UNS_type Dictionary_Define(SYM_type Variable)
  { if ((Current_scope_level == 0) &&
        Environment_Global_Overflow(Current_frame_size))
      return 0;
    Current_frame = make_FRM(Variable, 
                             Current_frame);
    return ++Current_frame_size; }

NIL_type Dictionary_Enter_Nested_Scope(NIL_type)
  { NBR_type c_frame_size;
    c_frame_size = make_NBR(Current_frame_size);
    Current_environment = make_ENV(Current_frame,
                                   c_frame_size,
                                   Current_environment);  
    Current_frame = Main_Empty_Frame;
    Current_frame_size = 0; 
    Current_scope_level++; }
  
UNS_type Dictionary_Exit_Nested_Scope(NIL_type)
  { NBR_type c_frame_size;
    UNS_type frame_size;
    frame_size = Current_frame_size;
    c_frame_size = Current_environment->siz;
    Current_frame = Current_environment->frm;
    Current_frame_size = c_frame_size->lng;
    Current_environment = Current_environment->env; 
    Current_scope_level--;
    return frame_size; }

UNS_type Dictionary_Get_Frame_Size(NIL_type)
  { return Current_frame_size; }

NIL_type Dictionary_Initialize(NIL_type)
  { Current_environment = Main_Empty_Environment;
    Current_scope_level = 0;
    Previous_frame = Current_frame = Main_Empty_Frame;
    Previous_frame_size = Current_frame_size = 0; }

UNS_type Dictionary_Lexical_Address(SYM_type   Variable,
                                    UNS_type * Scope   )
  { ENV_type environment;
    FRM_type frame;
    NBR_type c_frame_size;
    UNS_type frame_size,
             offset,
             scope;
    offset= get_offset(Variable,
                       Current_frame_size,
                       Current_frame);
    if (offset > 0)
      { *Scope = 0;
        return offset; }
    if (Current_scope_level > 0)
      { scope = Current_scope_level;
        for (environment = Current_environment;
             !is_NUL(environment);
             environment = environment->env)
          { c_frame_size = environment->siz;
            frame = environment->frm;
            frame_size = c_frame_size->lng;
            offset = get_offset(Variable,
                                frame_size,
                                frame);
            if (offset > 0)
              { *Scope = scope;
                return offset; }
            scope--; }}
    return 0; }
    
NIL_type Dictionary_Rollback(NIL_type)
  { NBR_type c_frame_size;
    Current_frame = Previous_frame;
    Current_frame_size = Previous_frame_size;
    c_frame_size = make_NBR(Current_frame_size);
    Current_environment = make_ENV(Current_frame,
                                   c_frame_size,
                                   Main_Empty_Environment);  
    Current_scope_level = 1; }
    