                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 8: lexical addressing   */
                     /*-----------------------------------*/
                     /*            environment            */
                     /*-----------------------------------*/

#include <stdio.h>

#include "SlipMain.h"
#include "SlipEnvironment.h"

/*------------------------------ private constants ---------------------------*/

enum { Environment_global_size = 64 };

/*------------------------------ private variables ---------------------------*/

static VEC_type Current_environment;
static VEC_type Current_frame;
static VEC_type Global_frame;

/*------------------------------ public functions ----------------------------*/

VEC_type Environment_Get_Environment(NIL_type)
  { return Current_environment; }

VEC_type Environment_Get_Frame(NIL_type)
  { return Current_frame; }
  
EXP_type Environment_Global_Get(UNS_type Scope,
                                UNS_type Offset)                                
  { EXP_type value;
    VEC_type frame;
    frame = Current_environment[Scope];
    value = frame[Offset];
    return value; }

BYT_type Environment_Global_Overflow(UNS_type Size)
  { return (Size >= Environment_global_size); }
                                  
NIL_type Environment_Global_Set(UNS_type Scope,
                                UNS_type Offset,
                                EXP_type Value)
  { VEC_type frame;
    frame = Current_environment[Scope];
    frame[Offset] = Value; } 
  
VEC_type Environment_Grow_Environment(NIL_type)
  { UNS_type index,
             size;
    VEC_type environment,
             frame;
    size = size_VEC(Current_environment);
    environment = make_VEC(++size);
    for (index = 1;
         index < size;
         index++)
      { frame = Current_environment[index];
        environment[index] = frame; }
    environment[size] = Current_frame; 
    return environment; }

NIL_type Environment_Initialize(NIL_type)
  { Current_environment = Main_Empty_Vector;
    Global_frame = Current_frame = make_VEC(Environment_global_size); }

EXP_type Environment_Local_Get(UNS_type Offset)                                
  { EXP_type value;
    value = Current_frame[Offset];
    return value; }

NIL_type Environment_Local_Set(UNS_type Offset,
                               EXP_type Value)
  { Current_frame[Offset] = Value; } 
  
NIL_type Environment_Rollback(NIL_type)
  { Current_environment = Main_Empty_Vector;
    Current_frame = Global_frame; }
    
NIL_type Environment_Set_Environment_And_Frame(VEC_type Environment,
                                               VEC_type Frame) 
  { Current_environment = Environment;
    Current_frame = Frame; }