; (load "QuickSort_bis.scm")

(begin
  (define t (clock))
  
  (define (swap V Left Right)
    (define save (vector-ref V Left))
    (vector-set! V Left (vector-ref V Right))
    (vector-set! V Right save))
    
  (define (median-of-3 V Left Right Middle)
     (if (> (vector-ref V Left) (vector-ref V Middle))
      (swap V Left Middle))
     (if (> (vector-ref V Left) (vector-ref V Right))
      (swap V Left Right))
     (if (> (vector-ref V Middle) (vector-ref V Right))
      (swap V Middle Right))
     (vector-ref V Middle))
            
  (define (QuickSort V Low High)
    (define Left Low)
    (define Right High)
    (define Middle (quotient (+ Left Right) 2))
    (define Pivot (median-of-3 V Left Right Middle))
    (while (< Left Right)
      (begin
        (while (< (vector-ref V Left) Pivot)
          (set! Left (+ Left 1)))
        (while (> (vector-ref V Right) Pivot)
          (set! Right (- Right 1)))
        (if (<= Left Right)
          (begin
            (swap V Left Right)
            (set! Left (+ Left 1))
            (set! Right (- Right 1))))))
    (if (< Low Right)
      (QuickSort V Low Right))
    (if (> High Left)
      (QuickSort V Left High)))
      
  (define V (make-vector 100 0))
  (define Low 0)
  (define High (- (vector-length V) 1))
  (define x 0)
  (define y 1)
  (while (< x (vector-length V))
    (begin
      (vector-set! V x y)
      (set! x (+ x 1))
      (set! y (remainder (+ y 4253171) 1235711))))
  (QuickSort V Low High)
  (display "elapsed: ")
  (display (- (clock) t))
  (display " sec")
  (newline)
  (vector-ref V High))
